# coding=utf-8
import string
from datetime import timedelta

import xbmcplugin


class URL:
    API = 'https://plugin.sc2.zone'
    GITLAB_URL = 'https://git.hotshot.sk/api/v4/'
    LOG_UPLOAD_URL = 'https://paste.kodi.tv/documents'
    OPEN_SUBTITLES = 'https://api.opensubtitles.org/xml-rpc'


class AUTH:
    TOKEN = '9ajdu4xyn1ig8nxsodr3'


class GENERAL:
    PLUGIN_ID = 'plugin.video.stream-cinema-2-release'
    VERSION_CHECK_INTERVAL = timedelta(minutes=1)
    API_TIMEOUT = 20
    VIP_REMAINING_DAYS_WARN = 30
    VIP_CHECK_INTERVAL = timedelta(days=1)
    DEFAULT_LANGUAGE = 'en'
    DIR_PAGE_LIMIT = 200
    MAX_URL_LENGTH = 8000


class TRAKT:
    SYNC_INTERVAL = 600


class LIBRARY:
    SYNC_INTERVAL = 86400
    SYNC_DELAY = 60


class DB_TABLE:
    WATCH_HISTORY = 'watch_history'
    PINNED = 'pinned'
    DOWNLOAD = 'download'
    TRAKT_LIST_ITEMS = 'trakt_list_items'
    TV_SHOWS_SUBSCRIPTIONS = 'tv_shows_subscriptions'
    HIDDEN = 'hidden'


class FILTER:
    STARTS_WITH_SIMPLE = 'startsWithSimple'
    GENRE = 'genre'
    SEARCH = 'search'
    SERVICE = 'service'
    PARENT = 'parent'
    ALL = 'all'
    STUDIO = 'studio'
    IDS = 'ids'
    NEWS_DUBBED = 'newsDubbed'
    NEWS = 'news'
    COUNTRY = 'country'
    YEAR = 'year'
    LANGUAGE = 'language'


class COUNT:
    TITLES = 'titles'
    GENRES = 'genres'
    STUDIOS = 'studios'
    COUNTRIES = 'countries'
    YEARS = 'years'
    LANGUAGES = 'languages'
    NUMBERS = 'numbers'


class QUERY:
    SORT = 'sort'
    TYPE = 'type'
    ORDER = 'order'
    LANG = 'lang'
    VALUE = 'value'
    SERVICE = 'service'
    ID = 'id'
    DAYS = 'days'
    FROM = 'from'
    LIMIT = 'limit'


class DIR_TYPE:
    VIDEOS = 'videos'
    MOVIES = 'movies'
    TV_SHOWS = 'tvshows'
    NONE = ''
    EPISODES = 'episodes'


class MEDIA_TYPE:
    TV_SHOW = 'tvshow'
    MOVIE = 'movie'
    SEASON = 'season'
    EPISODE = 'episode'
    ALL = '*'


class ENDPOINT:
    API = '/api'
    MEDIA = API + '/media'
    FILTER = MEDIA + '/filter/{filter_name}?{query}'
    SERVICE = MEDIA + '/service/{service_name}/{service_id}'
    MEDIA_PLAYED = MEDIA + '/played/{media_id}'
    POPULAR = MEDIA + '/popular?{query}'
    MEDIA_DETAIL = MEDIA + '/{media_id}'
    FILTER_COUNT = MEDIA + '/filter/{filter_name}/count/{count_name}?{query}'
    USERS = API + '/users'
    STREAMS = MEDIA + '/{media_id}/streams'
    STREAM = API + '/stream'
    STREAM_REPORT = STREAM + '/report/{stream_id}'


class ORDER:
    ASCENDING = 'asc'
    DESCENDING = 'desc'


class MEDIA_SERVICE:
    CSFD = 'csfd'
    TRAKT = 'trakt'
    TMDB = 'tmdb'
    TVDB = 'tvdb'
    FANART = 'fanart'
    TRAKT_WITH_TYPE = 'trakt_with_type'


class LANG_CODE:
    AA = 'aa'
    AB = 'ab'
    AF = 'af'
    AM = 'am'
    AR = 'ar'
    AS = 'as'
    AY = 'ay'
    AZ = 'az'
    BA = 'ba'
    BE = 'be'
    BG = 'bg'
    BH = 'bh'
    BI = 'bi'
    BN = 'bn'
    BO = 'bo'
    BR = 'br'
    BS = 'bs'
    CA = 'ca'
    CN = 'cn'
    CO = 'co'
    CS = 'cs'
    CY = 'cy'
    DA = 'da'
    DE = 'de'
    DZ = 'dz'
    EL = 'el'
    EN = 'en'
    EO = 'eo'
    ES = 'es'
    ET = 'et'
    EU = 'eu'
    FA = 'fa'
    FI = 'fi'
    FJ = 'fj'
    FO = 'fo'
    FR = 'fr'
    FY = 'fy'
    GA = 'ga'
    GD = 'gd'
    GL = 'gl'
    GN = 'gn'
    GU = 'gu'
    HA = 'ha'
    HE = 'he'
    HI = 'hi'
    HR = 'hr'
    HU = 'hu'
    HY = 'hy'
    IA = 'ia'
    ID = 'id'
    IE = 'ie'
    IK = 'ik'
    IS = 'is'
    IT = 'it'
    IU = 'iu'
    JA = 'ja'
    JI = 'ji'
    JW = 'jw'
    KA = 'ka'
    KK = 'kk'
    KL = 'kl'
    KM = 'km'
    KN = 'kn'
    KO = 'ko'
    KS = 'ks'
    KU = 'ku'
    KY = 'ky'
    LA = 'la'
    LN = 'ln'
    LO = 'lo'
    LT = 'lt'
    LV = 'lv'
    MG = 'mg'
    MI = 'mi'
    MK = 'mk'
    ML = 'ml'
    MN = 'mn'
    MO = 'mo'
    MR = 'mr'
    MS = 'ms'
    MT = 'mt'
    MY = 'my'
    NA = 'na'
    NE = 'ne'
    NL = 'nl'
    NO = 'no'
    OC = 'oc'
    OM = 'om'
    OR = 'or'
    PA = 'pa'
    PL = 'pl'
    PS = 'ps'
    PT = 'pt'
    QU = 'qu'
    RM = 'rm'
    RN = 'rn'
    RO = 'ro'
    RU = 'ru'
    RW = 'rw'
    SA = 'sa'
    SD = 'sd'
    SG = 'sg'
    SH = 'sh'
    SI = 'si'
    SK = 'sk'
    SL = 'sl'
    SM = 'sm'
    SN = 'sn'
    SO = 'so'
    SQ = 'sq'
    SR = 'sr'
    SS = 'ss'
    ST = 'st'
    SU = 'su'
    SV = 'sv'
    SW = 'sw'
    TA = 'ta'
    TE = 'te'
    TG = 'tg'
    TH = 'th'
    TI = 'ti'
    TK = 'tk'
    TL = 'tl'
    TN = 'tn'
    TO = 'to'
    TR = 'tr'
    TS = 'ts'
    TT = 'tt'
    TW = 'tw'
    UK = 'uk'
    UR = 'ur'
    UZ = 'uz'
    VI = 'vi'
    VO = 'vo'
    WO = 'wo'
    XH = 'xh'
    XX = 'xx'
    YO = 'yo'
    ZH = 'zh'
    ZU = 'zu'


languages = {
    LANG_CODE.CS: "Čeština",
    LANG_CODE.SK: "Slovenčina",
    LANG_CODE.EN: "English",
}

lang_code_gui = {
    LANG_CODE.CS: 'CZ',
    LANG_CODE.EN: 'EN',
    LANG_CODE.SK: 'SK'
}

lang_to_iso_3 = {
    LANG_CODE.CS: 'cze',
    LANG_CODE.EN: 'eng',
    LANG_CODE.SK: 'slo'
}


class AUDIO_CHANNEL:
    n6 = 5.1
    n8 = 7.1


audio_channels = {
    6: AUDIO_CHANNEL.n6,
    8: AUDIO_CHANNEL.n8
}


class SORT:
    SCORE = 'score'
    YEAR = 'year'
    PREMIERED = 'premiered'
    DATE_ADDED = 'dateAdded'
    TITLE = 'title'
    PLAY_COUNT = 'playCount'
    LAST_SEEN = 'lastSeen'
    EPISODE = 'episode'
    NEWS = 'news'
    POPULARITY = 'popularity'
    TRENDING = 'trending'
    LANG_DATE_ADDED = 'langDateAdded'


class QUALITY:
    n144p = '144p'
    n240p = '240p'
    n360p = '360p'
    n480p = '480p'
    n720p = '720p'
    n1080p = '1080p'
    n2160p = '2160p'
    n4320p = '4320p'


quality_map = {
    144: QUALITY.n144p,
    240: QUALITY.n240p,
    360: QUALITY.n360p,
    480: QUALITY.n480p,
    720: QUALITY.n720p,
    1080: QUALITY.n1080p,
    2160: QUALITY.n2160p,
    4320: QUALITY.n4320p,
}


# ADD SLASH TO MAKE IT VALID
class ROUTE:
    ROOT = 'plugin://plugin.video.stream-cinema-2-release/'
    MOVIES = ROOT + 'movies/'
    TV_SHOWS = ROOT + 'tv_shows/'
    A_TO_Z = ROOT + 'a_to_z/'
    FILTER = ROOT + 'filter/'
    SEARCH = ROOT + 'search/'
    COMMAND = ROOT + 'command/'
    MEDIA_MENU = ROOT + 'media/'
    MAIN_MENU = ROOT + 'main_menu/'
    GENRE_MENU = ROOT + 'genre_menu/'
    SEARCH_RESULT = ROOT + 'search_result/'
    SELECT_STREAM = ROOT + 'select_stream/'
    PLAY_STREAM = ROOT + 'play_stream/'
    POPULAR = ROOT + 'popular/'
    CLEAR_PATH = ROOT + 'clear-path/'
    WATCHED = ROOT + 'watched/'
    CSFD_TIPS = ROOT + 'csfd_tips/'
    GET_MEDIA = ROOT + 'get_media/'
    GET_A_Z_MEDIA = ROOT + 'get_a_z_media/'
    GET_SEARCH_MEDIA = ROOT + 'get_search_media/'
    GET_STREAMS = ROOT + 'get_streams/'
    GET_DOWNLOADED_STREAM = ROOT + 'get_downloaded_stream/'
    COUNT_MENU = ROOT + 'count_menu/'
    NEXT_PAGE = ROOT + 'next_page/'
    DOWNLOAD = ROOT + 'download/'
    DOWNLOAD_QUEUE = ROOT + 'download-queue/'
    PROCESS_MEDIA_ITEM = ROOT + 'process_media_item/'
    PLAY_TRAILER = ROOT + 'play_trailer/'
    TRAKT_COLLECTION = ROOT + 'trakt/collection'
    TRAKT_FRIENDS_LIST = ROOT + 'trakt/friends'
    TRAKT_HISTORY_LIST = ROOT + 'trakt/histories'
    TRAKT_HISTORY = ROOT + 'trakt/history'
    TRAKT_LISTS = ROOT + 'trakt/lists'
    TRAKT_LIST = ROOT + 'trakt/list'
    TRAKT_SPECIAL_LIST = ROOT + 'trakt/special-list'
    TRAKT_SYNC = ROOT + 'trakt/sync'
    HIDDEN_MENU_ITEMS = ROOT + 'hidden-menu-items'


class ACTION:
    PLAY = 'play'
    DOWNLOAD = 'download'


class DOWNLOAD_STATUS:
    DOWNLOADING = 'downloading'
    COMPLETED = 'completed'
    QUEUED = 'queued'
    PAUSED = 'paused'
    CANCELLED = 'cancelled'


class RENDER_TYPE:
    DEFAULT = 'default'
    A_Z = 'a-z'
    SEARCH = 'search'
    DOWNLOAD = 'download'


class CONTEXT_MENU:
    DELETE_HISTORY = 'delete_history'
    PIN = 'pin'
    DOWNLOAD = 'download'
    DELETE_DOWNLOAD = 'delete_download'
    START_DOWNLOAD = 'start_download'
    PAUSE_DOWNLOAD = 'pause_download'
    ADD_TO_LIBRARY = 'add_to_library'
    CHOOSE_STREAM = 'choose_stream'
    TRAKT = 'trakt'
    HIDE_MENU_ITEM = 'hide_menu_item'
    SHOW_MENU_ITEM = 'show_menu_item'


class GITLAB_ENDPOINT:
    RELEASES = 'projects/{project_id}/releases'


class COMMAND:
    OPEN_SETTINGS = 'open-settings'
    SHOW_LOG_PATH = 'show-log-path'
    UPLOAD_LOG = 'upload-log'
    ADD_TO_LIBRARY = 'add-to-library'
    CHECK_PROVIDER_CREDENTIALS = 'check-provider-credentials'
    DELETE_HISTORY_ALL = 'delete-history-all'
    REFRESH_PROVIDER_TOKEN = 'refresh-provider-token'
    SET_PROVIDER_CREDENTIALS = 'set-provider-credentials'
    SET_SUBTITLES_CREDENTIALS = 'set-subtitles-credentials'
    DELETE_HISTORY_ITEM = 'delete-history-item'
    PIN = 'pin'
    UNPIN = 'unpin'
    DELETE_DOWNLOAD_ITEM = 'delete-download-item'
    CANCEL_DOWNLOAD_ITEM = 'cancel-download-item'
    RESUME_DOWNLOAD_ITEM = 'resume-download-item'
    PAUSE_DOWNLOAD_ITEM = 'pause-download-item'
    TRAKT_LIST_APPEND = 'trakt-list-append'
    TRAKT_LIST_CLONE = 'trakt-list-clone'
    TRAKT_LIST_DELETE = 'trakt-list-delete'
    TRAKT_LIST_LIKE = 'trakt-list-like'
    TRAKT_LIST_RENAME = 'trakt-list-rename'
    TRAKT_LIST_UNLIKE = 'trakt-list-unlike'
    TRAKT_LOGIN = 'trakt-login'
    TRAKT_LOGOUT = 'trakt-logout'
    TRAKT_MEDIA_MENU = 'trakt-media-menu'
    TRAKT_UNFOLLOW = 'trakt-unfollow'
    UPDATE_TV_SHOWS = 'update-tv-shows'
    HIDE_MENU_ITEM = 'hide-menu-item'
    SHOW_MENU_ITEM = 'show-menu-item'


class HTTP_METHOD:
    GET = 'get'
    POST = 'post'


class REGEX:
    CSFD_ID = r'\/(\d+)-(?!.*\\/\d+-)|^[0-9]+$'


class STORAGE:
    COLLECTION = 'collection'
    MEDIA_LIST = 'media_list'
    PLUGIN_URL_HISTORY = 'plugin_url_history'
    PLUGIN_LAST_URL_ADDED = 'plugin_last_url_added'
    SELECTED_MEDIA_ID = 'selected_media_id'
    SERVICE = 'service'
    CLEARED_CACHE = 'cleared_cache'
    IS_OLD_KODI_SESSION = 'is_new_kodi_session'
    TRAKT_LAST_WATCHED = 'trakt.last_watched'
    TRAKT_LISTS = 'trakt.lists'
    TRAKT_PLAYED_ID = 'trakt.played_id'


class SERVICE:
    PLAYER_SERVICE = 'player_service'
    DOWNLOAD_SERVICE = 'download_service'
    TRAKT_SERVICE = 'trakt_service'
    LIBRARY_SERVICE = 'library_service'


class PLAYER_SERVICE_EVENT:
    PLAYBACK_STARTED = 'playback_started'
    PLAYBACK_STOPPED = 'playback_stopped'
    TRAKT_AUTHENTICATED = 'trakt_authenticated'


class DOWNLOAD_SERVICE_EVENT:
    ITEM_ADDED = 'item_added'
    ITEM_RESUMED = 'item_resumed'


class CACHE:
    EXPIRATION_TIME = 10
    EXPIRATION_TIME_BIGGER = 30
    PLUGIN_URL_HISTORY_LIMIT = 5


class DOWNLOAD_TYPE:
    VIDEO_STREAM = 'video_stream'
    FILE_DOWNLOAD = 'file_download'


class SETTINGS:
    VERSION = 'version'
    UUID = 'uuid'
    DEBUG = 'debug'
    PROVIDER_NAME = 'provider.name'
    PROVIDER_USERNAME = 'provider.username'
    PROVIDER_PASSWORD = 'provider.password'
    PROVIDER_TOKEN = 'provider.token'
    PROVIDER_LOGGED_IN = 'provider.logged_in'
    SHOW_CODEC = 'show_codec'
    SHOW_BITRATE = 'show_bitrate'
    SHOW_DURATION = 'show_duration'
    SHOW_HDR = 'show_hdr'
    SHOW_HDR_STREAMS = 'show_hdr_streams'
    EXPLICIT_CONTENT = 'explicit_content'
    ADVANCED_CLEAR_CACHE = 'advanced.clear_cache'
    FILE_SIZE_SORT = 'file_size_sort'
    INSTALLATION_DATE = 'installation_date'
    LAST_VERSION_CHECK = 'last_version_check'
    LAST_VERSION_AVAILABLE = 'last_version_available'
    A_Z_THRESHOLD = 'a_z_threshold'
    IS_OUTDATED = 'is_outdated'
    VIP_DURATION = 'provider.vip_duration'
    LAST_VIP_CHECK = 'last_vip_check'
    SHOW_RESULTS_COUNT = 'show_results_count'
    STREAM_AUTOSELECT_PREFERRED_QUALITY = 'auto_select_stream.preferred_quality'
    PREFERRED_LANGUAGE = 'preferred_language'
    FALLBACK_LANGUAGE = 'fallback_language'
    MOVIE_LIBRARY_FOLDER = 'movie_library_folder'
    TV_SHOW_LIBRARY_FOLDER = 'tvshow_library_folder'
    SHOW_TOP_NAVIGATION = 'show_top_navigation'
    SUBTITLES_PROVIDER_USERNAME = 'subtitles_provider.username'
    SUBTITLES_PROVIDER_PASSWORD = 'subtitles_provider.password'
    SUBTITLES_PROVIDER_TOKEN = 'subtitles_provider.token'
    SUBTITLES_PROVIDER_PREFERRED_LANGUAGE = 'subtitles_provider.preferred_language'
    SUBTITLES_PROVIDER_FALLBACK_LANGUAGE = 'subtitles_provider.fallback_language'
    TRAKT_AUTHENTICATION = 'trakt.authentication'
    TRAKT_DISPLAY_NAME = 'trakt.display_name'
    TRAKT_NAME = 'trakt.name'
    TRAKT_USER_ID = 'trakt.user_id'
    GENRES_COUNT = 'genres_count'
    PLAYED_ITEMS_HISTORY = 'played_items_history'
    DOWNLOADS_FOLDER = 'downloads_folder'
    DOWNLOADS_NOTIFY = 'downloads_perc_notify'
    DOWNLOADS_PARALLEL_DL = 'downloads_parallel_dl'
    LIBRARY_AUTO_NEW = 'library_auto_new'
    LIBRARY_AUTO_NEW_DUBBED = 'library_auto_new_dubbed'
    LIBRARY_AUTO_COUNT = 'library_auto_count'
    SHOW_HIDDEN = 'show_hidden'
    PAGE_LIMIT = 'page_limit'
    SHOW_LANGUAGE_TITLE = 'show_language_title'
    SHOW_YEAR_TITLE = 'show_year_title'
    NEWS_LIMIT = 'news_limit'
    NEWS_DUBBED_LIMIT = 'news_dubbed_limit'


class COLOR:
    FLORALWHITE = 'floralwhite'
    BLUE = 'blue'
    RED = 'red'
    IVORY = 'ivory'
    CORNSILK = 'cornsilk'
    LIGHTYELLOW = 'lightyellow'
    GOLD = 'gold'


class STRINGS:
    STREAM_TITLE_BRACKETS = '[{}]'
    STREAM_BITRATE_BRACKETS = '[I]{}[/I]'
    AUDIO_INFO = '[{} {} {}]'
    BOLD = '[B]{}[/B]'
    TABLE_SPACES = '  '
    DATETIME = '%Y-%m-%d %H:%M:%S'
    ISO_FORMAT = '%Y-%m-%dT%H:%M:%S.%f'
    COUNT_TITLE = '{}  [I][COLOR grey]({})[/COLOR][/I]'
    REGEX_BRACKETS = '[{}]'
    COLOR = '[COLOR {color}]{text}[/COLOR]'
    COLOR_GREEN = '[COLOR green]{}[/COLOR]'
    COLOR_RED = '[COLOR red]{}[/COLOR]'
    COLOR_BLUE = '[COLOR blue]{}[/COLOR]'
    NEW_LINE = '\n'
    PAIR = '{}: {}'
    PAIR_BOLD = BOLD + ': {}'
    SEASON_TITLE = 'S{season}'
    EPISODE_TITLE = 'E{episode}'
    SEASON_EPISODE_TITLE = 'S{season}E{episode}'
    VIP_INFO = '{} ({}: {})'
    TITLE_YEAR = '{title} [LIGHT][COLOR darkgray]({year})[/COLOR][/LIGHT]'
    TITLE_GENRE = '{title} [LIGHT][COLOR darkgray]{genre}[/COLOR][/LIGHT]'
    TV_SHOW_TITLE = '[COLOR white][B]{root_title}[/B] [COLOR grey]{numbering}[/COLOR] {title}'
    TV_SHOW_NUM_TITLE = '{number}   {title}'
    TITLE_AUDIO_INFO = '[COLOR lightskyblue]{audio}[/COLOR][COLOR darkgray] · [/COLOR]{title}'
    TITLE_STREAM_AVAILABLE = '[COLOR red]×[/COLOR] {title}'
    QUERY = '{}?{}'
    TITLE_CHAIN_SEPARATOR = ' - '
    EMPTY = ''
    NEWS_DUBBED_DIR_TITLE = '{title}[COLOR lightskyblue][COLOR darkgray] · [/COLOR]{languages}[/COLOR]'
    SUBTITLES_SEARCH_TITLE = '{title} ({year})'
    SUBTITLES_SEARCH_TV_SHOW_TITLE = '{title} {numbering}'
    NEW_VERSION_AVAILABLE = '[COLOR lightskyblue]{version}[/COLOR] → [COLOR greenyellow]{new_version}[/COLOR]'
    NEW_VERSION_TITLE = '{title} | {versions}'
    CHANGELOG = '{text}\n\n[B]{changelog}[/B]\n{description}'
    PINNED_ITEM = '[COLOR gold]★ [/COLOR]{item}'
    PIN_ITEM = '[COLOR gold]★ [/COLOR]{item}'
    UNPIN_ITEM = '[B][COLOR red]☆ [/COLOR][/B]{item}'
    RUN_PLUGIN = 'XBMC.RunPlugin({0})'
    DOWNLOAD_TITLE = '[COLOR lightgreen][B]{progress}%[/B][/COLOR] | {title}'


class CODEC:
    H265 = 'HEVC'
    H264 = 'H264'


class LANG:
    GENERAL = 30010
    SOURCE = 30011
    USERNAME = 30101
    PASSWORD = 30102
    PROVIDER = 30103
    WEBSHARE_CZ = 30104
    ADVANCED = 30012
    INSTALLATION_DATE = 30013
    INTERFACE = 30014
    SHOW_CODEC = 30115
    SHOW_BITRATE = 30116
    THRESHOLDS = 30118
    A_Z_THRESHOLD = 30119
    DEBUG = 30105
    PIN = 30141
    UNPIN = 30142
    MOVIES = 30200
    SERIES = 30201
    MAIN_MENU = 30202
    NEXT_PAGE = 30203
    SEARCH = 30204
    SEARCH_MEDIA = 30207
    SETTINGS = 30208
    GENRE = 30209
    A_Z = 30210
    POPULAR = 30211
    WATCHING_NOW = 30212
    ACTION = 30213
    ANIMATED = 30214
    ADVENTURE = 30215
    DOCUMENTARY = 30216
    DRAMA = 30217
    EROTIC = 30218
    FANTASY = 30219
    HISTORICAL = 30220
    HORROR = 30221
    MUSIC = 30222
    IMAX = 30223
    CATASTROPHIC = 30224
    COMEDY = 30225
    SHORT = 30226
    CRIME = 30227
    MUSICAL = 30228
    MYSTERIOUS = 30229
    EDUCATIONAL = 30230
    FAIRYTALE = 30231
    PORNOGRAPHIC = 30232
    PSYCHOLOGICAL = 30233
    JOURNALISTIC = 30234
    REALITY = 30235
    TRAVEL = 30236
    FAMILY = 30237
    ROMANTIC = 30238
    SCI_FI = 30239
    COMPETITION = 30240
    SPORTS = 30241
    STAND_UP = 30242
    TALK_SHOW = 30243
    TELENOVELA = 30244
    THRILLER = 30245
    MILITARY = 30246
    WESTERN = 30247
    BIOGRAPHICAL = 30248
    ANIMATION = 30249
    SELECT_A_MEDIA_SOURCE = 30250
    ZERO_NINE = 30251
    SEARCH_FOR_LETTERS = 30252
    CHOOSE_STREAM = 30253
    WATCH_HISTORY = 30254
    BY_STUDIO = 30255
    BY_YEAR = 30256
    BY_COUNTRY = 30257
    BY_DURATION = 30258
    BY_LANGUAGE = 30259
    NUMBERS = 30260
    TRENDING = 30261
    MOST_WATCHED = 30262
    SEASON = 30920
    EPISODE = 30921
    MISSING_PROVIDER_CREDENTIALS = 30300
    NOTHING_FOUND = 30302
    FOUND__NUM__RECORDS = 30303
    ACTIVATE_VIP = 30304
    NEW_VERSION_TITLE = 30307
    NEW_VERSION_TEXT = 30308
    PAGE_LIMIT = 30120
    PROVIDER_DETAILS = 30123
    VERIFY_LOGIN_INFORMATION = 30122
    TOKEN = 30121
    INCORRECT_PROVIDER_CREDENTIALS = 30124
    INFO = 30126
    TOKEN_REFRESHED = 30127
    CORRECT_PROVIDER_CREDENTIALS = 30128
    SHOW_DURATION = 30129
    VIP_REMAINS = 30130
    DAYS = 30132
    NOT_ACTIVE = 30133
    CSFD_TIPS = 30309
    SHOW_SEARCH_RESULTS_NOTIFICATIONS = 30135
    NEWS = 30136
    LAST_ADDED = 30137
    NEWS_DUBBED = 30139
    SUCCESSFULLY_DOWNLOADED = 30144
    STARTING_DOWNLOAD = 30145
    ALREADY_DOWNLOADING = 30146
    LIST_IS_EMPTY = 30147
    SUB = 30148
    HDR = 30149
    HIDE = 30151
    SHOW = 30152
    MOVE_BACK = 30153
    HIDDEN = 30154
    CHOOSE_LANGUAGE = 30310
    CHOOSE_FALLBACK_LANGUAGE = 30311
    AUTO_SUBTITLES = 30313
    PLUGIN_WAS_UPDATED = 30314
    MISSING_STREAM_TITLE = 30315
    MISSING_STREAM_TEXT = 30316
    TELL_US_ABOUT_IT = 30319
    STREAM_FLAGGED_UNAVAILABLE = 30320
    CHANGELOG = 30317
    STREAM_NOT_AVAILABLE = 30318
    LOG_FILE_PATH = 30410
    PLAYED_ITEMS_HISTORY = 30615
    DELETE_ITEM_FROM_HISTORY = 30616
    DELETE_ALL_HISTORY = 30617
    HISTORY_DELETED = 30618
    DOWNLOAD = 30619
    DL_DIR_NOT_SET = 30621
    DOWNLOAD_QUEUE = 30622
    DELETE = 30624
    CANCEL_DOWNLOAD = 30625
    PAUSE_DOWNLOAD = 30626
    RESUME_DOWNLOAD = 30627
    DOWNLOAD_AGAIN = 30628

    # add to library context menu item
    ADD_TO_LIBRARY = 30350

    # network errors
    HTTP_ERROR = 30500
    SERVER_ERROR_HELP = 30501
    CONNECTION_ERROR = 30510
    NO_CONNECTION_HELP = 30511

    # INTRO
    INTRO_TITLE_1 = 30600
    INTRO_TEXT_1 = 30601
    INTRO_TITLE_2 = 30602
    INTRO_TEXT_2 = 30603
    INTRO_TITLE_3 = 30604
    INTRO_TEXT_3 = 30605
    INTRO_TEXT_4 = 30606
    INTRO_TITLE_4 = 30607
    INTRO_TITLE_5 = 30608
    INTRO_TITLE_6 = 30609
    INTRO_TEXT_7 = 30610
    INTRO_TITLE_7 = 30611
    INTRO_TEXT_8 = 30612
    INTRO_TITLE_8 = 30613
    INTRO_TEXT_9 = 30614

    # trakt 30700 - 30899
    TRAKT_LOGIN_HEADER = 30701
    TRAKT_LOGIN_TEXT = 30702
    TRAKT_LOGOUT_HEADER = 30703
    TRAKT_LOGOUT_MESSAGE = 30704
    TRAKT_MY_LISTS = 30708
    TRAKT_WATCHLIST = 30709
    TRAKT_HISTORY = 30710
    TRAKT_RATED_MOVIES = 30711
    TRAKT_RATED_SHOWS = 30712
    TRAKT_WATCHED_MOVIES = 30713
    TRAKT_WATCHED_SHOWS = 30714
    TRAKT_FRIENDS_LIST = 30715
    TRAKT_COLLECTION = 30718
    TRAKT_LIKED_LISTS = 30719
    TRAKT_POPULAR_LISTS = 30720
    TRAKT_TRENDING_LISTS = 30721
    TRAKT_LIST_DELETE = 30722
    TRAKT_LIST_DELETE_MESSAGE = 30723
    TRAKT_LIST_DELETED_MESSAGE = 30724
    TRAKT_MEDIA_MENU = 30725
    TRAKT_MEDIA_MENU_TITLE = 30726
    TRAKT_RATE = 30727
    TRAKT_ADD_TO_WATCHLIST = 30728
    TRAKT_REMOVE_FROM_WATCHLIST = 30729
    TRAKT_UNFOLLOW = 30730
    TRAKT_UNFOLLOWED_HEADER = 30731
    TRAKT_RATE_TITLE = 30743
    TRAKT_ADD_TO_LIST = 30744
    TRAKT_REMOVE_FROM_LIST = 30745
    TRAKT_ADD_TO_NEW_LIST = 30746
    TRAKT_RATING_ADDED = 30747
    TRAKT_RATING_REMOVED = 30748
    TRAKT_NEW_LIST_NAME = 30749
    TRAKT_ADDED_TO_LIST = 30750
    TRAKT_REMOVED_FROM_LIST = 30751
    TRAKT_LIST_LIKE = 30752
    TRAKT_LIST_UNLIKE = 30753
    TRAKT_LIST_CLONE = 30754
    TRAKT_LIST_APPEND = 30755
    TRAKT_LIST_LIKED_MESSAGE = 30756
    TRAKT_LIST_UNLIKED_MESSAGE = 30757
    TRAKT_LIST_RENAME = 30758
    TRAKT_LIST_RENAMED_MESSAGE = 30759
    TRAKT_LIST_APPEND_CHOICE_HEADER = 30760
    TRAKT_LIST_APPENDED_HEADER = 30761
    TRAKT_LIST_APPENDED_MESSAGE = 30762
    TRAKT_LIST_CLONED_MESSAGE = 30763
    TRAKT_LIST_CLONE_HEADER = 30764
    TRAKT_LIST_CLONE_MESSAGE = 30765
    TRAKT_CANT_CREATE_LIST = 30766
    TRAKT_TRY_AGAIN_LATER = 30767
    TRAKT_LOGGED_OUT_TITLE = 30768
    TRAKT_LOGGED_OUT_MESSAGE = 30769
    TRAKT_LOGGED_IN_TITLE = 30770
    TRAKT_LOGGED_IN_MESSAGE = 30771

    # COUNTRIES
    ALGERIA = 31000
    ARGENTINA = 31001
    ARMENIA = 31002
    ARUBA = 31003
    AUSTRALIA = 31004
    AUSTRIA = 31005
    AZERBAIJAN = 31006
    BAHAMAS = 31007
    BANGLADESH = 31008
    BELARUS = 31009
    BELGIUM = 31010
    BHUTAN = 31011
    BOLIVIA = 31012
    BOSNIA_AND_HERZEGOVINA = 31013
    BOTSWANA = 31014
    BRAZIL = 31015
    BRUNEI = 31016
    BULGARIA = 31017
    CAMBODIA = 31018
    CANADA = 31019
    CHILE = 31020
    CHINA = 31021
    COLOMBIA = 31022
    COSTA_RICA = 31023
    CROATIA = 31024
    CUBA = 31025
    CYPRUS = 31026
    CZECHIA = 31027
    CZECHOSLOVAKIA = 31028
    DEMOCRATIC_REPUBLIC_OF_THE_CONGO = 31029
    DENMARK = 31030
    DOMINICAN_REPUBLIC = 31031
    EAST_GERMANY = 31032
    EGYPT = 31033
    ESTONIA = 31034
    FED_REP_YUGOSLAVIA = 31035
    FINLAND = 31036
    FRANCE = 31037
    FRENCH_POLYNESIA = 31038
    GEORGIA = 31039
    GERMAN_EMPIRE = 31040
    GERMANY = 31041
    GHANA = 31042
    GREECE = 31043
    HAITI = 31044
    HONG_KONG = 31045
    HUNGARY = 31046
    ICELAND = 31047
    INDIA = 31048
    INDONESIA = 31049
    IRAN = 31050
    IRAQ = 31051
    IRELAND = 31052
    ISRAEL = 31053
    ITALY = 31054
    JAMAICA = 31055
    JAPAN = 31056
    JORDAN = 31057
    KAZAKHSTAN = 31058
    KENYA = 31059
    LAOS = 31060
    LATVIA = 31061
    LEBANON = 31062
    LICHTENSTEIN = 31063
    LITHUANIA = 31064
    LUXEMBOURG = 31065
    MACAO = 31066
    MACEDONIA = 31067
    MALAYSIA = 31068
    MALTA = 31069
    MEXICO = 31070
    MONACO = 31071
    MONGOLIA = 31072
    MONTENEGRO = 31073
    MOROCCO = 31074
    NAMIBIA = 31075
    NEPAL = 31076
    NETHERLANDS = 31077
    NEW_ZEALAND = 31078
    NIGERIA = 31079
    NORTH_KOREA = 31080
    NORWAY = 31081
    PAKISTAN = 31082
    PALESTINE = 31083
    PANAMA = 31084
    PAPUA_NEW_GUINEA = 31085
    PARAGUAY = 31086
    PERU = 31087
    PHILIPPINES = 31088
    POLAND = 31089
    PORTUGAL = 31090
    PUERTO_RICO = 31091
    QATAR = 31092
    ROMANIA = 31093
    RUSSIA = 31094
    SAUDI_ARABIA = 31095
    SENEGAL = 31096
    SERBIA = 31097
    SERBIA_AND_MONTENEGRO = 31098
    SINGAPORE = 31099
    SLOVAKIA = 31100
    SLOVENIA = 31101
    SOUTH_AFRICAN_REPUBLIC = 31102
    SOUTH_KOREA = 31103
    SPAIN = 31104
    SWEDEN = 31105
    SWITZERLAND = 31106
    SYRIA = 31107
    TAIWAN = 31108
    TANZANIA = 31109
    THAILAND = 31110
    THE_SOVIET_UNION = 31111
    TUNISIA = 31112
    TURKEY = 31113
    UGANDA = 31114
    UKRAINE = 31115
    UNITED_ARAB_EMIRATES = 31116
    UNITED_KINGDOM = 31117
    UNITED_STATES_OF_AMERICA = 31118
    URUGUAY = 31119
    VENEZUELA = 31120
    VIETNAM = 31121
    WEST_GERMANY = 31122
    YUGOSLAVIA = 31123
    ZIMBABWE = 31124

    # LANGUAGES
    AFAR = 32000
    ABKHAZIAN = 32001
    AFRIKAANS = 32002
    AMHARIC = 32003
    ARABIC = 32004
    ASSAMESE = 32005
    AYMARA = 32006
    AZERBAIJANI = 32007
    BASHKIR = 32008
    BYELORUSSIAN = 32009
    BULGARIAN = 32010
    BIHARI = 32011
    BISLAMA = 32012
    BENGALI_BANGLA = 32013
    TIBETAN = 32014
    BRETON = 32015
    CATALAN = 32016
    CORSICAN = 32017
    CZECH = 32018
    WELSH = 32019
    DANISH = 32020
    GERMAN = 32021
    BHUTANI = 32022
    GREEK = 32023
    ENGLISH = 32024
    ESPERANTO = 32025
    SPANISH = 32026
    ESTONIAN = 32027
    BASQUE = 32028
    PERSIAN = 32029
    FINNISH = 32030
    FIJI = 32031
    FAEROESE = 32032
    FRENCH = 32033
    FRISIAN = 32034
    IRISH = 32035
    SCOTS_GAELIC = 32036
    GALICIAN = 32037
    GUARANI = 32038
    GUJARATI = 32039
    HAUSA = 32040
    HEBREW = 32041
    HINDI = 32042
    CROATIAN = 32043
    HUNGARIAN = 32044
    ARMENIAN = 32045
    INTERLINGUA = 32046
    INDONESIAN = 32047
    INTERLINGUE = 32048
    INUPIAK = 32049
    ICELANDIC = 32050
    ITALIAN = 32051
    JAPANESE = 32052
    YIDDISH = 32053
    JAVANESE = 32054
    GEORGIAN = 32055
    KAZAKH = 32056
    GREENLANDIC = 32057
    CAMBODIAN = 32058
    KANNADA = 32059
    KOREAN = 32060
    KASHMIRI = 32061
    KURDISH = 32062
    KIRGHIZ = 32063
    LATIN = 32064
    LINGALA = 32065
    LAOTHIAN = 32066
    LITHUANIAN = 32067
    LATVIAN_LETTISH = 32068
    MALAGASY = 32069
    MAORI = 32070
    MACEDONIAN = 32071
    MALAYALAM = 32072
    MONGOLIAN = 32073
    MOLDAVIAN = 32074
    MARATHI = 32075
    MALAY = 32076
    MALTESE = 32077
    BURMESE = 32078
    NAURU = 32079
    NEPALI = 32080
    DUTCH = 32081
    NORWEGIAN = 32082
    OCCITAN = 32083
    OROMO = 32084
    ORIYA = 32085
    PUNJABI = 32086
    POLISH = 32087
    PASHTO_PUSHTO = 32088
    PORTUGUESE = 32089
    QUECHUA = 32090
    RHAETO_ROMANCE = 32091
    KIRUNDI = 32092
    ROMANIAN = 32093
    RUSSIAN = 32094
    KINYARWANDA = 32095
    SANSKRIT = 32096
    SINDHI = 32097
    SANGRO = 32098
    SERBO_CROATIAN = 32099
    SINGHALESE = 32100
    SLOVAK = 32101
    SLOVENIAN = 32102
    SAMOAN = 32103
    SHONA = 32104
    SOMALI = 32105
    ALBANIAN = 32106
    SERBIAN = 32107
    SISWATI = 32108
    SESOTHO = 32109
    SUNDANESE = 32110
    SWEDISH = 32111
    SWAHILI = 32112
    TAMIL = 32113
    TEGULU = 32114
    TAJIK = 32115
    THAI = 32116
    TIGRINYA = 32117
    TURKMEN = 32118
    TAGALOG = 32119
    SETSWANA = 32120
    TONGA = 32121
    TURKISH = 32122
    TSONGA = 32123
    TATAR = 32124
    TWI = 32125
    UKRAINIAN = 32126
    URDU = 32127
    UZBEK = 32128
    VIETNAMESE = 32129
    VOLAPUK = 32130
    WOLOF = 32131
    XHOSA = 32132
    YORUBA = 32133
    CHINESE = 32134
    ZULU = 32135
    BOSNIAN = 32136
    INUKTITUT = 32137
    NO_LANGUAGE = 32138


class COUNTRY:
    ALGERIA = 'Algeria'
    ARGENTINA = 'Argentina'
    ARMENIA = 'Armenia'
    ARUBA = 'Aruba'
    AUSTRALIA = 'Australia'
    AUSTRIA = 'Austria'
    AZERBAIJAN = 'Azerbaijan'
    BAHAMAS = 'Bahamas'
    BANGLADESH = 'Bangladesh'
    BELARUS = 'Belarus'
    BELGIUM = 'Belgium'
    BHUTAN = 'Bhutan'
    BOLIVIA = 'Bolivia'
    BOSNIA_AND_HERZEGOVINA = 'Bosnia and Herzegovina'
    BOTSWANA = 'Botswana'
    BRAZIL = 'Brazil'
    BRUNEI = 'Brunei'
    BULGARIA = 'Bulgaria'
    CAMBODIA = 'Cambodia'
    CANADA = 'Canada'
    CHILE = 'Chile'
    CHINA = 'China'
    COLOMBIA = 'Colombia'
    COSTA_RICA = 'Costa Rica'
    CROATIA = 'Croatia'
    CUBA = 'Cuba'
    CYPRUS = 'Cyprus'
    CZECHIA = 'Czechia'
    CZECHOSLOVAKIA = 'Czechoslovakia'
    DEMOCRATIC_REPUBLIC_OF_THE_CONGO = 'Democratic Republic of the Congo'
    DENMARK = 'Denmark'
    DOMINICAN_REPUBLIC = 'Dominican republic'
    EAST_GERMANY = 'East Germany'
    EGYPT = 'Egypt'
    ESTONIA = 'Estonia'
    FED_REP_YUGOSLAVIA = 'Fed. Rep. Yugoslavia'
    FINLAND = 'Finland'
    FRANCE = 'France'
    FRENCH_POLYNESIA = 'French Polynesia'
    GEORGIA = 'Georgia'
    GERMAN_EMPIRE = 'German Empire'
    GERMANY = 'Germany'
    GHANA = 'Ghana'
    GREECE = 'Greece'
    HAITI = 'Haiti'
    HONG_KONG = 'Hong Kong'
    HUNGARY = 'Hungary'
    ICELAND = 'Iceland'
    INDIA = 'India'
    INDONESIA = 'Indonesia'
    IRAN = 'Iran'
    IRAQ = 'Iraq'
    IRELAND = 'Ireland'
    ISRAEL = 'Israel'
    ITALY = 'Italy'
    JAMAICA = 'Jamaica'
    JAPAN = 'Japan'
    JORDAN = 'Jordan'
    KAZAKHSTAN = 'Kazakhstan'
    KENYA = 'Kenya'
    LAOS = 'Laos'
    LATVIA = 'Latvia'
    LEBANON = 'Lebanon'
    LICHTENSTEIN = 'Lichtenstein'
    LITHUANIA = 'Lithuania'
    LUXEMBOURG = 'Luxembourg'
    MACAO = 'Macao'
    MACEDONIA = 'Macedonia'
    MALAYSIA = 'Malaysia'
    MALTA = 'Malta'
    MEXICO = 'Mexico'
    MONACO = 'Monaco'
    MONGOLIA = 'Mongolia'
    MONTENEGRO = 'Montenegro'
    MOROCCO = 'Morocco'
    NAMIBIA = 'Namibia'
    NEPAL = 'Nepal'
    NETHERLANDS = 'Netherlands'
    NEW_ZEALAND = 'New Zealand'
    NIGERIA = 'Nigeria'
    NORTH_KOREA = 'North Korea'
    NORWAY = 'Norway'
    PAKISTAN = 'Pakistan'
    PALESTINE = 'Palestine'
    PANAMA = 'Panama'
    PAPUA_NEW_GUINEA = 'Papua New Guinea'
    PARAGUAY = 'Paraguay'
    PERU = 'Peru'
    PHILIPPINES = 'Philippines'
    POLAND = 'Poland'
    PORTUGAL = 'Portugal'
    PUERTO_RICO = 'Puerto Rico'
    QATAR = 'Qatar'
    ROMANIA = 'Romania'
    RUSSIA = 'Russia'
    SAUDI_ARABIA = 'Saudi Arabia'
    SENEGAL = 'Senegal'
    SERBIA = 'Serbia'
    SERBIA_AND_MONTENEGRO = 'Serbia and Montenegro'
    SINGAPORE = 'Singapore'
    SLOVAKIA = 'Slovakia'
    SLOVENIA = 'Slovenia'
    SOUTH_AFRICAN_REPUBLIC = 'South African Republic'
    SOUTH_KOREA = 'South Korea'
    SPAIN = 'Spain'
    SWEDEN = 'Sweden'
    SWITZERLAND = 'Switzerland'
    SYRIA = 'Syria'
    TAIWAN = 'Taiwan'
    TANZANIA = 'Tanzania'
    THAILAND = 'Thailand'
    THE_SOVIET_UNION = 'The Soviet Union'
    TUNISIA = 'Tunisia'
    TURKEY = 'Turkey'
    UGANDA = 'Uganda'
    UKRAINE = 'Ukraine'
    UNITED_ARAB_EMIRATES = 'United Arab Emirates'
    UNITED_KINGDOM = 'United Kingdom'
    UNITED_STATES_OF_AMERICA = 'United States of America'
    URUGUAY = 'Uruguay'
    VENEZUELA = 'Venezuela'
    VIETNAM = 'Vietnam'
    WEST_GERMANY = 'West Germany'
    YUGOSLAVIA = 'Yugoslavia'
    ZIMBABWE = 'Zimbabwe'


language_lang = {
    LANG_CODE.AA: LANG.AFAR,
    LANG_CODE.AB: LANG.ABKHAZIAN,
    LANG_CODE.AF: LANG.AFRIKAANS,
    LANG_CODE.AM: LANG.AMHARIC,
    LANG_CODE.AR: LANG.ARABIC,
    LANG_CODE.AS: LANG.ASSAMESE,
    LANG_CODE.AY: LANG.AYMARA,
    LANG_CODE.AZ: LANG.AZERBAIJANI,
    LANG_CODE.BA: LANG.BASHKIR,
    LANG_CODE.BE: LANG.BYELORUSSIAN,
    LANG_CODE.BG: LANG.BULGARIAN,
    LANG_CODE.BH: LANG.BIHARI,
    LANG_CODE.BI: LANG.BISLAMA,
    LANG_CODE.BN: LANG.BENGALI_BANGLA,
    LANG_CODE.BO: LANG.TIBETAN,
    LANG_CODE.BR: LANG.BRETON,
    LANG_CODE.BS: LANG.BOSNIAN,
    LANG_CODE.CA: LANG.CATALAN,
    LANG_CODE.CO: LANG.CORSICAN,
    LANG_CODE.CS: LANG.CZECH,
    LANG_CODE.CN: LANG.CHINESE,
    LANG_CODE.CY: LANG.WELSH,
    LANG_CODE.DA: LANG.DANISH,
    LANG_CODE.DE: LANG.GERMAN,
    LANG_CODE.DZ: LANG.BHUTANI,
    LANG_CODE.EL: LANG.GREEK,
    LANG_CODE.EN: LANG.ENGLISH,
    LANG_CODE.EO: LANG.ESPERANTO,
    LANG_CODE.ES: LANG.SPANISH,
    LANG_CODE.ET: LANG.ESTONIAN,
    LANG_CODE.EU: LANG.BASQUE,
    LANG_CODE.FA: LANG.PERSIAN,
    LANG_CODE.FI: LANG.FINNISH,
    LANG_CODE.FJ: LANG.FIJI,
    LANG_CODE.FO: LANG.FAEROESE,
    LANG_CODE.FR: LANG.FRENCH,
    LANG_CODE.FY: LANG.FRISIAN,
    LANG_CODE.GA: LANG.IRISH,
    LANG_CODE.GD: LANG.SCOTS_GAELIC,
    LANG_CODE.GL: LANG.GALICIAN,
    LANG_CODE.GN: LANG.GUARANI,
    LANG_CODE.GU: LANG.GUJARATI,
    LANG_CODE.HA: LANG.HAUSA,
    LANG_CODE.HE: LANG.HEBREW,
    LANG_CODE.HI: LANG.HINDI,
    LANG_CODE.HR: LANG.CROATIAN,
    LANG_CODE.HU: LANG.HUNGARIAN,
    LANG_CODE.HY: LANG.ARMENIAN,
    LANG_CODE.IA: LANG.INTERLINGUA,
    LANG_CODE.ID: LANG.INDONESIAN,
    LANG_CODE.IE: LANG.INTERLINGUE,
    LANG_CODE.IK: LANG.INUPIAK,
    LANG_CODE.IS: LANG.ICELANDIC,
    LANG_CODE.IT: LANG.ITALIAN,
    LANG_CODE.IU: LANG.INUKTITUT,
    LANG_CODE.JA: LANG.JAPANESE,
    LANG_CODE.JI: LANG.YIDDISH,
    LANG_CODE.JW: LANG.JAVANESE,
    LANG_CODE.KA: LANG.GEORGIAN,
    LANG_CODE.KK: LANG.KAZAKH,
    LANG_CODE.KL: LANG.GREENLANDIC,
    LANG_CODE.KM: LANG.CAMBODIAN,
    LANG_CODE.KN: LANG.KANNADA,
    LANG_CODE.KO: LANG.KOREAN,
    LANG_CODE.KS: LANG.KASHMIRI,
    LANG_CODE.KU: LANG.KURDISH,
    LANG_CODE.KY: LANG.KIRGHIZ,
    LANG_CODE.LA: LANG.LATIN,
    LANG_CODE.LN: LANG.LINGALA,
    LANG_CODE.LO: LANG.LAOTHIAN,
    LANG_CODE.LT: LANG.LITHUANIAN,
    LANG_CODE.LV: LANG.LATVIAN_LETTISH,
    LANG_CODE.MG: LANG.MALAGASY,
    LANG_CODE.MI: LANG.MAORI,
    LANG_CODE.MK: LANG.MACEDONIAN,
    LANG_CODE.ML: LANG.MALAYALAM,
    LANG_CODE.MN: LANG.MONGOLIAN,
    LANG_CODE.MO: LANG.MOLDAVIAN,
    LANG_CODE.MR: LANG.MARATHI,
    LANG_CODE.MS: LANG.MALAY,
    LANG_CODE.MT: LANG.MALTESE,
    LANG_CODE.MY: LANG.BURMESE,
    LANG_CODE.NA: LANG.NAURU,
    LANG_CODE.NE: LANG.NEPALI,
    LANG_CODE.NL: LANG.DUTCH,
    LANG_CODE.NO: LANG.NORWEGIAN,
    LANG_CODE.OC: LANG.OCCITAN,
    LANG_CODE.OM: LANG.OROMO,
    LANG_CODE.OR: LANG.ORIYA,
    LANG_CODE.PA: LANG.PUNJABI,
    LANG_CODE.PL: LANG.POLISH,
    LANG_CODE.PS: LANG.PASHTO_PUSHTO,
    LANG_CODE.PT: LANG.PORTUGUESE,
    LANG_CODE.QU: LANG.QUECHUA,
    LANG_CODE.RM: LANG.RHAETO_ROMANCE,
    LANG_CODE.RN: LANG.KIRUNDI,
    LANG_CODE.RO: LANG.ROMANIAN,
    LANG_CODE.RU: LANG.RUSSIAN,
    LANG_CODE.RW: LANG.KINYARWANDA,
    LANG_CODE.SA: LANG.SANSKRIT,
    LANG_CODE.SD: LANG.SINDHI,
    LANG_CODE.SG: LANG.SANGRO,
    LANG_CODE.SH: LANG.SERBO_CROATIAN,
    LANG_CODE.SI: LANG.SINGHALESE,
    LANG_CODE.SK: LANG.SLOVAK,
    LANG_CODE.SL: LANG.SLOVENIAN,
    LANG_CODE.SM: LANG.SAMOAN,
    LANG_CODE.SN: LANG.SHONA,
    LANG_CODE.SO: LANG.SOMALI,
    LANG_CODE.SQ: LANG.ALBANIAN,
    LANG_CODE.SR: LANG.SERBIAN,
    LANG_CODE.SS: LANG.SISWATI,
    LANG_CODE.ST: LANG.SESOTHO,
    LANG_CODE.SU: LANG.SUNDANESE,
    LANG_CODE.SV: LANG.SWEDISH,
    LANG_CODE.SW: LANG.SWAHILI,
    LANG_CODE.TA: LANG.TAMIL,
    LANG_CODE.TE: LANG.TEGULU,
    LANG_CODE.TG: LANG.TAJIK,
    LANG_CODE.TH: LANG.THAI,
    LANG_CODE.TI: LANG.TIGRINYA,
    LANG_CODE.TK: LANG.TURKMEN,
    LANG_CODE.TL: LANG.TAGALOG,
    LANG_CODE.TN: LANG.SETSWANA,
    LANG_CODE.TO: LANG.TONGA,
    LANG_CODE.TR: LANG.TURKISH,
    LANG_CODE.TS: LANG.TSONGA,
    LANG_CODE.TT: LANG.TATAR,
    LANG_CODE.TW: LANG.TWI,
    LANG_CODE.UK: LANG.UKRAINIAN,
    LANG_CODE.UR: LANG.URDU,
    LANG_CODE.UZ: LANG.UZBEK,
    LANG_CODE.VI: LANG.VIETNAMESE,
    LANG_CODE.VO: LANG.VOLAPUK,
    LANG_CODE.WO: LANG.WOLOF,
    LANG_CODE.XH: LANG.XHOSA,
    LANG_CODE.XX: LANG.NO_LANGUAGE,
    LANG_CODE.YO: LANG.YORUBA,
    LANG_CODE.ZH: LANG.CHINESE,
    LANG_CODE.ZU: LANG.ZULU,
}


class GENRE:
    EROTIC = 'Erotic'
    PORNOGRAPHIC = 'Pornographic'
    ACTION = 'Action'
    ANIMATED = 'Animated'
    ANIMATION = 'Animation'
    ADVENTURE = 'Adventure'
    BIOGRAPHICAL = 'Biographical'
    CATASTROPHIC = 'Catastrophic'
    COMEDY = 'Comedy'
    COMPETITION = 'Competition'
    CRIME = 'Crime'
    DOCUMENTARY = 'Documentary'
    FAIRYTALE = 'Fairytale'
    DRAMA = 'Drama'
    FAMILY = 'Family'
    FANTASY = 'Fantasy'
    HISTORICAL = 'Historical'
    HORROR = 'Horror'
    IMAX = 'IMAX'
    EDUCATIONAL = 'Educational'
    MUSIC = 'Music'
    JOURNALISTIC = 'Journalistic'
    MILITARY = 'Military'
    MUSICAL = 'Musical'
    MYSTERIOUS = 'Mysterious'
    PSYCHOLOGICAL = 'Psychological'
    REALITY = 'Reality'
    ROMANTIC = 'Romantic'
    SCI_FI = 'Sci-Fi'
    SHORT = 'Short'
    SPORTS = 'Sports'
    STAND_UP = 'Stand-Up'
    TALK_SHOW = 'Talk-Show'
    TELENOVELA = 'Telenovela'
    THRILLER = 'Thriller'
    TRAVEL = 'Travel'
    WESTERN = 'Western'


genre_lang = {
    GENRE.EROTIC: LANG.EROTIC,
    GENRE.PORNOGRAPHIC: LANG.PORNOGRAPHIC,
    GENRE.ACTION: LANG.ACTION,
    GENRE.ANIMATED: LANG.ANIMATED,
    GENRE.ANIMATION: LANG.ANIMATION,
    GENRE.ADVENTURE: LANG.ADVENTURE,
    GENRE.BIOGRAPHICAL: LANG.BIOGRAPHICAL,
    GENRE.CATASTROPHIC: LANG.CATASTROPHIC,
    GENRE.COMEDY: LANG.COMEDY,
    GENRE.COMPETITION: LANG.COMPETITION,
    GENRE.CRIME: LANG.CRIME,
    GENRE.DOCUMENTARY: LANG.DOCUMENTARY,
    GENRE.FAIRYTALE: LANG.FAIRYTALE,
    GENRE.DRAMA: LANG.DRAMA,
    GENRE.FAMILY: LANG.FAMILY,
    GENRE.FANTASY: LANG.FANTASY,
    GENRE.HISTORICAL: LANG.HISTORICAL,
    GENRE.HORROR: LANG.HORROR,
    GENRE.IMAX: LANG.IMAX,
    GENRE.EDUCATIONAL: LANG.EDUCATIONAL,
    GENRE.MUSIC: LANG.MUSIC,
    GENRE.JOURNALISTIC: LANG.JOURNALISTIC,
    GENRE.MILITARY: LANG.MILITARY,
    GENRE.MUSICAL: LANG.MUSICAL,
    GENRE.MYSTERIOUS: LANG.MYSTERIOUS,
    GENRE.PSYCHOLOGICAL: LANG.PSYCHOLOGICAL,
    GENRE.REALITY: LANG.REALITY,
    GENRE.ROMANTIC: LANG.ROMANTIC,
    GENRE.SCI_FI: LANG.SCI_FI,
    GENRE.SHORT: LANG.SHORT,
    GENRE.SPORTS: LANG.SPORTS,
    GENRE.STAND_UP: LANG.STAND_UP,
    GENRE.TALK_SHOW: LANG.TALK_SHOW,
    GENRE.TELENOVELA: LANG.TELENOVELA,
    GENRE.THRILLER: LANG.THRILLER,
    GENRE.TRAVEL: LANG.TRAVEL,
    GENRE.WESTERN: LANG.WESTERN
}

country_lang = {
    COUNTRY.ALGERIA: LANG.ALGERIA,
    COUNTRY.ARGENTINA: LANG.ARGENTINA,
    COUNTRY.ARMENIA: LANG.ARMENIA,
    COUNTRY.ARUBA: LANG.ARUBA,
    COUNTRY.AUSTRALIA: LANG.AUSTRALIA,
    COUNTRY.AUSTRIA: LANG.AUSTRIA,
    COUNTRY.AZERBAIJAN: LANG.AZERBAIJAN,
    COUNTRY.BAHAMAS: LANG.BAHAMAS,
    COUNTRY.BANGLADESH: LANG.BANGLADESH,
    COUNTRY.BELARUS: LANG.BELARUS,
    COUNTRY.BELGIUM: LANG.BELGIUM,
    COUNTRY.BHUTAN: LANG.BHUTAN,
    COUNTRY.BOLIVIA: LANG.BOLIVIA,
    COUNTRY.BOSNIA_AND_HERZEGOVINA: LANG.BOSNIA_AND_HERZEGOVINA,
    COUNTRY.BOTSWANA: LANG.BOTSWANA,
    COUNTRY.BRAZIL: LANG.BRAZIL,
    COUNTRY.BRUNEI: LANG.BRUNEI,
    COUNTRY.BULGARIA: LANG.BULGARIA,
    COUNTRY.CAMBODIA: LANG.CAMBODIA,
    COUNTRY.CANADA: LANG.CANADA,
    COUNTRY.CHILE: LANG.CHILE,
    COUNTRY.CHINA: LANG.CHINA,
    COUNTRY.COLOMBIA: LANG.COLOMBIA,
    COUNTRY.COSTA_RICA: LANG.COSTA_RICA,
    COUNTRY.CROATIA: LANG.CROATIA,
    COUNTRY.CUBA: LANG.CUBA,
    COUNTRY.CYPRUS: LANG.CYPRUS,
    COUNTRY.CZECHIA: LANG.CZECHIA,
    COUNTRY.CZECHOSLOVAKIA: LANG.CZECHOSLOVAKIA,
    COUNTRY.DEMOCRATIC_REPUBLIC_OF_THE_CONGO: LANG.DEMOCRATIC_REPUBLIC_OF_THE_CONGO,
    COUNTRY.DENMARK: LANG.DENMARK,
    COUNTRY.DOMINICAN_REPUBLIC: LANG.DOMINICAN_REPUBLIC,
    COUNTRY.EAST_GERMANY: LANG.EAST_GERMANY,
    COUNTRY.EGYPT: LANG.EGYPT,
    COUNTRY.ESTONIA: LANG.ESTONIA,
    COUNTRY.FED_REP_YUGOSLAVIA: LANG.FED_REP_YUGOSLAVIA,
    COUNTRY.FINLAND: LANG.FINLAND,
    COUNTRY.FRANCE: LANG.FRANCE,
    COUNTRY.FRENCH_POLYNESIA: LANG.FRENCH_POLYNESIA,
    COUNTRY.GEORGIA: LANG.GEORGIA,
    COUNTRY.GERMAN_EMPIRE: LANG.GERMAN_EMPIRE,
    COUNTRY.GERMANY: LANG.GERMANY,
    COUNTRY.GHANA: LANG.GHANA,
    COUNTRY.GREECE: LANG.GREECE,
    COUNTRY.HAITI: LANG.HAITI,
    COUNTRY.HONG_KONG: LANG.HONG_KONG,
    COUNTRY.HUNGARY: LANG.HUNGARY,
    COUNTRY.ICELAND: LANG.ICELAND,
    COUNTRY.INDIA: LANG.INDIA,
    COUNTRY.INDONESIA: LANG.INDONESIA,
    COUNTRY.IRAN: LANG.IRAN,
    COUNTRY.IRAQ: LANG.IRAQ,
    COUNTRY.IRELAND: LANG.IRELAND,
    COUNTRY.ISRAEL: LANG.ISRAEL,
    COUNTRY.ITALY: LANG.ITALY,
    COUNTRY.JAMAICA: LANG.JAMAICA,
    COUNTRY.JAPAN: LANG.JAPAN,
    COUNTRY.JORDAN: LANG.JORDAN,
    COUNTRY.KAZAKHSTAN: LANG.KAZAKHSTAN,
    COUNTRY.KENYA: LANG.KENYA,
    COUNTRY.LAOS: LANG.LAOS,
    COUNTRY.LATVIA: LANG.LATVIA,
    COUNTRY.LEBANON: LANG.LEBANON,
    COUNTRY.LICHTENSTEIN: LANG.LICHTENSTEIN,
    COUNTRY.LITHUANIA: LANG.LITHUANIA,
    COUNTRY.LUXEMBOURG: LANG.LUXEMBOURG,
    COUNTRY.MACAO: LANG.MACAO,
    COUNTRY.MACEDONIA: LANG.MACEDONIA,
    COUNTRY.MALAYSIA: LANG.MALAYSIA,
    COUNTRY.MALTA: LANG.MALTA,
    COUNTRY.MEXICO: LANG.MEXICO,
    COUNTRY.MONACO: LANG.MONACO,
    COUNTRY.MONGOLIA: LANG.MONGOLIA,
    COUNTRY.MONTENEGRO: LANG.MONTENEGRO,
    COUNTRY.MOROCCO: LANG.MOROCCO,
    COUNTRY.NAMIBIA: LANG.NAMIBIA,
    COUNTRY.NEPAL: LANG.NEPAL,
    COUNTRY.NETHERLANDS: LANG.NETHERLANDS,
    COUNTRY.NEW_ZEALAND: LANG.NEW_ZEALAND,
    COUNTRY.NIGERIA: LANG.NIGERIA,
    COUNTRY.NORTH_KOREA: LANG.NORTH_KOREA,
    COUNTRY.NORWAY: LANG.NORWAY,
    COUNTRY.PAKISTAN: LANG.PAKISTAN,
    COUNTRY.PALESTINE: LANG.PALESTINE,
    COUNTRY.PANAMA: LANG.PANAMA,
    COUNTRY.PAPUA_NEW_GUINEA: LANG.PAPUA_NEW_GUINEA,
    COUNTRY.PARAGUAY: LANG.PARAGUAY,
    COUNTRY.PERU: LANG.PERU,
    COUNTRY.PHILIPPINES: LANG.PHILIPPINES,
    COUNTRY.POLAND: LANG.POLAND,
    COUNTRY.PORTUGAL: LANG.PORTUGAL,
    COUNTRY.PUERTO_RICO: LANG.PUERTO_RICO,
    COUNTRY.QATAR: LANG.QATAR,
    COUNTRY.ROMANIA: LANG.ROMANIA,
    COUNTRY.RUSSIA: LANG.RUSSIA,
    COUNTRY.SAUDI_ARABIA: LANG.SAUDI_ARABIA,
    COUNTRY.SENEGAL: LANG.SENEGAL,
    COUNTRY.SERBIA: LANG.SERBIA,
    COUNTRY.SERBIA_AND_MONTENEGRO: LANG.SERBIA_AND_MONTENEGRO,
    COUNTRY.SINGAPORE: LANG.SINGAPORE,
    COUNTRY.SLOVAKIA: LANG.SLOVAKIA,
    COUNTRY.SLOVENIA: LANG.SLOVENIA,
    COUNTRY.SOUTH_AFRICAN_REPUBLIC: LANG.SOUTH_AFRICAN_REPUBLIC,
    COUNTRY.SOUTH_KOREA: LANG.SOUTH_KOREA,
    COUNTRY.SPAIN: LANG.SPAIN,
    COUNTRY.SWEDEN: LANG.SWEDEN,
    COUNTRY.SWITZERLAND: LANG.SWITZERLAND,
    COUNTRY.SYRIA: LANG.SYRIA,
    COUNTRY.TAIWAN: LANG.TAIWAN,
    COUNTRY.TANZANIA: LANG.TANZANIA,
    COUNTRY.THAILAND: LANG.THAILAND,
    COUNTRY.THE_SOVIET_UNION: LANG.THE_SOVIET_UNION,
    COUNTRY.TUNISIA: LANG.TUNISIA,
    COUNTRY.TURKEY: LANG.TURKEY,
    COUNTRY.UGANDA: LANG.UGANDA,
    COUNTRY.UKRAINE: LANG.UKRAINE,
    COUNTRY.UNITED_ARAB_EMIRATES: LANG.UNITED_ARAB_EMIRATES,
    COUNTRY.UNITED_KINGDOM: LANG.UNITED_KINGDOM,
    COUNTRY.UNITED_STATES_OF_AMERICA: LANG.UNITED_STATES_OF_AMERICA,
    COUNTRY.URUGUAY: LANG.URUGUAY,
    COUNTRY.VENEZUELA: LANG.VENEZUELA,
    COUNTRY.VIETNAM: LANG.VIETNAM,
    COUNTRY.WEST_GERMANY: LANG.WEST_GERMANY,
    COUNTRY.YUGOSLAVIA: LANG.YUGOSLAVIA,
    COUNTRY.ZIMBABWE: LANG.ZIMBABWE,
}

explicit_genres = [GENRE.EROTIC, GENRE.PORNOGRAPHIC]

a_z_threshold_options = {
    0: 10,
    1: 20,
    2: 30,
}


class ICON:
    GENRE = 'genre.png'
    A_Z = 'az.png'
    A_Z_2 = 'az2.png'
    NUMBERS = 'numbers.png'
    NEW = 'new.png'
    NEW_DUB = 'new_dub.png'
    POPULAR = 'popular.png'
    RECENT = 'recent.png'
    TV = 'csfd.png'
    STUDIO = 'studio.png'
    MOVIES = 'movies.png'
    TVSHOWS = 'tvshows.png'
    HISTORY = 'history.png'
    SEARCH = 'search.png'
    SETTINGS = 'settings.png'
    COUNTRY = 'country.png'
    YEAR = 'year.png'
    LANGUAGE = 'language.png'
    DOWNLOAD = 'download.png'
    NEXT = 'defaultfoldernext.png'
    TRAKT = 'trakt.png'
    TRAKT_ERROR = 'trakt-error.png'
    TRAKT_FRIEND = 'trakt-friend.png'
    TRAKT_FRIENDS = 'trakt-friends.png'
    TRAKT_FOLLOWING = 'trakt-following.png'
    TRAKT_HISTORY = 'history.png'
    TRAKT_LIST = 'trakt-list.png'
    TRAKT_LIST_LIKED = 'trakt-list-liked.png'
    TRAKT_LIST_POPULAR = 'trakt-list-popular.png'
    TRAKT_LIST_TRENDING = 'trakt-list-trending.png'
    TRAKT_ALICORN = 'alicorn.png'
    TRAKT_CHRISTMAS = 'tree-christmas.png'
    TRAKT_WATCHED = 'trakt-watched.png'
    TRAKT_WATCHLIST = 'trakt-watchlist.png'
    TRENDING = 'trending.png'
    MOST_WATCHED = 'chart-line-solid-2.png'


class ICON_PATH:
    COUNTRY = 'country/{}.png'


numbers = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9']
common_chars = [' ', '-', ':']

alphabet = {
    LANG_CODE.CS: ['a', 'á', 'b', 'c', 'č', 'd', 'ď', 'e', 'é', 'ě', 'f', 'g', 'h', 'ch', 'i', 'í', 'j', 'k', 'l', 'm',
                   'n', 'ň', 'o', 'ó', 'p', 'q', 'r', 'ř', 's', 'š', 't', 'ť', 'u', 'ú', 'ů', 'v', 'w', 'x', 'y', 'ý',
                   'z', 'ž', ],
    LANG_CODE.SK: ['a', 'á', 'ä', 'b', 'c', 'č', 'd', 'ď', 'dz', 'dž', 'e', 'é', 'f', 'g', 'h', 'ch', 'i', 'í', 'j',
                   'k', 'l', 'ĺ', 'ľ', 'm', 'n', 'ň', 'o', 'ó', 'ô', 'p', 'q', 'r', 'ŕ', 's', 'š', 't', 'ť', 'u', 'ú',
                   'v', 'w', 'x', 'y', 'ý', 'z', 'ž'],
}

lang_countries = {
    LANG_CODE.CS: [COUNTRY.CZECHIA, COUNTRY.CZECHOSLOVAKIA],
    LANG_CODE.SK: [COUNTRY.SLOVAKIA, COUNTRY.CZECHOSLOVAKIA],
}

trakt_type_map = {
    'movie': MEDIA_TYPE.MOVIE,
    'show': MEDIA_TYPE.TV_SHOW,
    'episode': MEDIA_TYPE.EPISODE,
    'season': MEDIA_TYPE.SEASON
}


class TRAKT_LIST:
    WATCHED = 'watched'


class MEDIA_SERVICE:
    TRAKT = 'trakt'
    TMDB = 'tmdb'
    IMDB = 'imdb'
    TVDB = 'tvdb'


sort_methods = [
    xbmcplugin.SORT_METHOD_UNSORTED,
    xbmcplugin.SORT_METHOD_VIDEO_RATING,
    xbmcplugin.SORT_METHOD_MPAA_RATING,
    xbmcplugin.SORT_METHOD_VIDEO_SORT_TITLE,
    xbmcplugin.SORT_METHOD_DATEADDED,
    xbmcplugin.SORT_METHOD_VIDEO_YEAR,
    xbmcplugin.SORT_METHOD_DURATION,
    xbmcplugin.SORT_METHOD_VIDEO_RUNTIME,
]


class MENU_ITEM:
    A_Z = 1
    STUDIOS = 2
    GENRES = 3
    COUNTRIES = 4
    LANGUAGES = 5
    YEARS = 6
    NEW_RELEASES = 7
    NEW_RELEASES_DUBBED = 8
    POPULAR = 9
    TRENDING = 10
    LAST_ADDED = 11
    MOST_WATCHED = 12
    CSFD_TIPS = 13
