"""
    Stream cinema service.
"""

import xbmc

from resources.lib.defaults import Defaults
from resources.lib.kodilogging import service_logger
from resources.lib.kodilogging import setup_root_logger
from resources.lib.players.stream_cinema_player import StreamCinemaPlayer
from resources.lib.services.download_service import DownloadService
from resources.lib.services.player_service import PlayerService
from resources.lib.services.trakt_service import TraktService
from resources.lib.services.library_service import LibraryService
                                                          
setup_root_logger()
threads = []
service_logger.debug('Service started')
player_service = PlayerService(Defaults.api())
download_service = DownloadService(Defaults.api(), threads)
stream_cinema_player = StreamCinemaPlayer(service=player_service)
download_service.resume_download()
trakt_service = TraktService()
trakt_service.sync_lists()
library_service = LibraryService()
library_service.sync_tv_shows()
xbmc_monitor = xbmc.Monitor()
while not xbmc_monitor.abortRequested():
    # Do some stuff periodically. Since we have nothing to do for now, just block indefinitely.
    # Anyway we have to keep this blocked otherwise Player will get discarded.
    # if download_service.is_all_done():
        # if ROUTE.DOWNLOAD_QUEUE == current_path():
        #     refresh()
    stream_cinema_player.monitor()
    xbmc_monitor.waitForAbort(1)

for thread in threads:
    thread.join()

# TODO: Fix warnings about some classes left in a memory:
# https://forum.kodi.tv/showthread.php?tid=307508&pid=2531105#pid2531105
service_logger.debug('Service stopped')
